Package com.io7m.smfj.core

## Class SMFMetadataValue.Builder

- java.lang.Object
- - com.io7m.smfj.core.SMFMetadataValue.Builder

- Enclosing class:
    SMFMetadataValue

      public static final class SMFMetadataValue.Builder
      extends java.lang.Object

  Builds instances of type `SMFMetadataValue`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

  `Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `SMFMetadataValue` | `build()` | Builds a new `SMFMetadataValue`.
    `SMFMetadataValue.Builder` | `from​(SMFMetadataValueType instance)` | Fill a builder with attribute values from the provided `SMFMetadataValueType` instance.
    `SMFMetadataValue.Builder` | `setData​(byte... data)` | Initializes the value for the `data` attribute.
    `SMFMetadataValue.Builder` | `setSchemaId​(SMFSchemaIdentifier schemaId)` | Initializes the value for the `schemaId` attribute.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### from

          public final SMFMetadataValue.Builder from​(SMFMetadataValueType instance)

      Fill a builder with attribute values from the provided `SMFMetadataValueType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
      Parameters:
        `instance` - The instance from which to copy values
      Returns:
        `this` builder for use in a chained invocation

    - #### setSchemaId

          public final SMFMetadataValue.Builder setSchemaId​(SMFSchemaIdentifier schemaId)

      Initializes the value for the `schemaId` attribute.
      Parameters:
        `schemaId` - The value for schemaId
      Returns:
        `this` builder for use in a chained invocation

    - #### setData

          public final SMFMetadataValue.Builder setData​(byte... data)

      Initializes the value for the `data` attribute.
      Parameters:
        `data` - The elements for data
      Returns:
        `this` builder for use in a chained invocation

    - #### build

          public SMFMetadataValue build()

      Builds a new `SMFMetadataValue`.
      Returns:
        An immutable instance of SMFMetadataValue
      Throws:
        `java.lang.IllegalStateException` - if any required attributes are missing